package mydate;

public class Date
{
	// properties
	private int	day;
	private int	month;
	private int	year;

	// constructors

	// default to today's date
	public Date()
	{
		// using current API
		java.util.Calendar tmp;
		tmp = java.util.Calendar.getInstance();
		day = tmp.get( java.util.Calendar.DATE );
		month = tmp.get( java.util.Calendar.MONTH ) + 1;	
		// Java month is 0..11
		year = tmp.get( java.util.Calendar.YEAR );
	}

	public Date( int day, int month, int year)
	{
		this.day = day;
		this.month = month;
		this.year = year;
	}

	// copy constructor
	public Date( Date date)
	{
		day = date.day;
		month = date.month;
		year = date.year;
	}

	// methods
	public int getDay()
	{
		return day;
	}

	public int getMonth()
	{
		return month;
	}

	public int getYear()
	{
		return year;
	}

	// my clone method; not part of Java's framework!
	public Date clone()
	{
		return new Date( day, month, year);
	}


	public int getAge()
	{
		int	age;

		Date	today;
		today = new Date();

		age = today.year - this.year;
		if ( today.month < this.month)
			age--;
		if ( today.month == this.month
			 && today.day < this.day )
		age--;
		return age;
	}
	
	
	public boolean equals( Date otherDate)
	{
		return day == otherDate.day
			   && month == otherDate.month
			   && year == otherDate.year;
	}
	
	/*public boolean equals( Object o)
	{
		// more bulletproofing...
		if ( o == null)
			return false;
		if ( this.getClass() != o.getClass() )
			return false;
		
		Date date = (Date)o;
		return this.day == date.day
				   && this.month == date.month
				   && this.year == date.year;
	}*/

	public int compareTo( Date otherDate)
	{
		return 0;	// todo
	}

	public String toString()
	{
		return day + "/" + month + "/" + year;
	}

}
